#include<bits/stdc++.h>
#define ll long long
#define P 1e9+7
using namespace std;
ll p[500010];
ll find(ll x){
	if(p[x]!=x){
		p[x]=find(p[x]);
	}
	return p[x];
}
struct node{
	ll u;
	ll v;
}dl[1000020];
ll dfs(ll n){
	ll m=n-1;
	if(n==2)return 5;
	return n*(ll)pow(2,m)+2*dfs(n-1)*2;
}
int main(){
	freopen("barrack.in","r",stdin);
	freopen("barrack.out","w",stdout);
	ll n,m;
	scanf("%lld%lld",&n,&m);
	for(ll i=1;i<=n;i++){
		p[i]=i;
	}
	for(ll i=1;i<=m;i++){
		ll uu,vv;
		scanf("%lld%lld",&uu,&vv);
		dl[i].u=uu,dl[i].v=vv;
	}
	printf("%lld",dfs(n));
	return 0;
}
